<?php
/**
 * @version		1.2.0
 * @package		Simple Accordeon content plugin
 * @author		ConseilGouz
 * @copyright	Copyright (C) 2021 ConseilGouz. All rights reserved.
 * @license		GNU/GPL v2; see LICENSE.php
 **/
// no direct access
defined( '_JEXEC' ) or die;
jimport( 'joomla.event.plugin' );
class plgContentSimpleAccordeon extends JPlugin {
	public function onContentPrepare( $context, &$article, &$params, $page = 0 )
	{
		JHtml::_('jquery.framework');     // 1.1.1 : force jquery loading

		// first figure out whether to use article id or item_id:
		if (!((isset($article->item_id)) || (isset($article->id)))) {return;} // 1.0.12
		$id = isset($article->item_id) ? $article->item_id : $article->id;
		// simple performance check to determine whether bot should process further
		$shortcode = $this->params->get('shortcode','accordeon'); 
		if (strpos($article->text, '{'.$shortcode.'') === false ) {
			return true;
		}
		$regex = '/{'.$shortcode.'[\s\S]+?{\/'.$shortcode.'}*\s*/'; // get each accordeon chunk
	 	// find all instances of slides and put in $matches
		if (preg_match_all($regex, $article->text, $accordeon)) { // make sure there is a match
			$plg	= ''.JURI::base(true).'/plugins/content/simpleaccordeon/';
			$document	= JFactory::getDocument(); // 1.0.12
			$document->addStyleSheet($plg.'simpleaccordeon.css');
			$document->addScript($plg.'simpleaccordeon.js');  // 1.1.0 : CSP compatibility
			$bgcolor = $this->params->get('backgroundcolor'); 
			$chrcolor = $this->params->get('chrcolor'); 
			$selbgcolor = $this->params->get('selbgcolor'); 
			$fontsize = $this->params->get('fontsize','15px'); 
			$document->addStyleDeclaration('button.accordeon {background-color: '.$bgcolor.';color:'.$chrcolor.' !important;font-size:'.$fontsize.';line-height:'.$fontsize.'}');
			$document->addStyleDeclaration('button.accordeon.active, button.accordeon:hover {background-color: '.$selbgcolor.';}');
			// prep more specific regex:
			// add something to strip <br>s, like (?:<br ?\/?\>)
			$regex = '/(?:<(div|p)[^>]*>)?{'.$shortcode.'(?:=(.+))?}(?(1) *<\/\1>)?([\s\S]+?)(?:<(div|p)[^>]*>)?{\/'.$shortcode.'}(?(4) *<\/\4>)/i';
			foreach($accordeon[0] as $key=>$accordeon) {
				if (preg_match_all($regex, $accordeon, $matches, PREG_SET_ORDER)) { // ensure the more specific regex matches
					$identifier = 'acc' . $id . '_' . ($key+1);
					foreach ($matches as $match) {
						// $match[0] is full pattern match, $match[1] is an html tag wrapping '{accordeon ...}' (if found),
						// $match[2] is the title (toggler), $match[3] is the actual block,
						// $match[4] is an html tag wrapping '{/accordeon}' (if found)
						$output = '';
						// Make sure we've got what we need:
						if ($match[3]) {
							$tag = array();
							// 1.0.9 : add |open to open accordion as default behavior
							$strdisplay ='none';
							$stractive = '';
							if (strpos($match[2],'|open') > 0 ) {
							    $match[2] = str_replace('|open','',$match[2]);
								$strdisplay ='block';
								$stractive = 'active';
							}
							$tag[1]= '<button id="'.$identifier.'" class="accordeon '.$stractive.'">'.$match[2].'</button>';
							$tag[2] = '<div class="acc_panel" id="panel'.$identifier.'" style="display:'.$strdisplay.'">'.$match[3].'</div>';
							$output .= $tag[1] . $tag[2];
						}
						$article->text = str_replace($match[0], $output, $article->text);
					}
				}
			}
			$article->text = $article->text;
		}
	}
}
?>
